﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

/*
   Uno script che implementa la dinamica di una particella 
   implementata con Vertet integration e Position Based dynamics.
   Questo script va associato ad ogni particella presente nel gioco.
   NB: è solo un esercizio. Usando Unity, si può attivare la dinamica semplicemente associando un RigidBody ad un gameObject.
*/

public class DinamicaParticella : MonoBehaviour
{
    /* stato della particella (con Verlet) */
    Vector3 pos;   // posizione attuale di questa particella
    Vector3 oldPos; // posizione di questa particella al fotogramma precedente

    // unity chiama Start (su ogni gameObject) all'inizio del gioco
    void Start()
    {
        // eredita la "nostra"  posizione dal resto del game engine
        pos = transform./*global*/position;

        // init di Verlet (per oggetti che partono da fermi, cioè con speed=0)
        oldPos = pos;  
    }

    // Unity chiama Update (su ogni game-object) subito prima di ogni RENDERING
    void Update(){
        // imponi la "nostra" posizione al resto del game engine (in spazio MONDO!)
        // in modo tale che la particella appaia a schermo nella posizione che abbiamo calcolato
        transform./*global*/position = pos;
    }

    
    // Unity chiama FixedUpdate (su ogni game-object) per ogni passo della FISICA
    void FixedUpdate()
    {
        pos.y += 0.02f; // test scemo: sposta la particella in su (di 2cm per passo di fisica)
        // TODO: implementare sistema di Verlet qui
    }
}
